'<%
'************************************************
' File:    Xref Gruppi-Utenti.vbs
' Autore:  Giovanni Cenati 
'          Visualizza la cross reference dei gruppi 
'          e degli utenti del dominio.
'          http://digilander.libero.it/Cenati
'************************************************
Set WshShell = WScript.CreateObject("WScript.Shell")
Dim strGruppo(100)

' Ottiene il nome del dominio
strDomain = WshShell.ExpandEnvironmentStrings("%USERDOMAIN%")

Conferma = msgbox ("Creazione del file excel con l'elenco degli utenti e dei gruppi. Continuare?",vbyesno, "Cross Reference Gruppi-Utenti")
if Conferma =vbno then wscript.quit 'Se premuto annulla

Set objDomain = GetObject("WinNT://" & strDomain)
objDomain.Filter = Array("group")

'EXCEL: crea oggetto, lo rende visibile, aggiunge un foglio di lavoro.
Dim oXL
Set oXL = WScript.CreateObject("Excel.Application")
oXL.Visible = TRUE
oXL.WorkBooks.Add

' Crea la lista dei gruppi da due in su,
' la memorizza in un array e la scrive in excel
oXL.Cells(1, 1).Value = Date
i=1
For Each objGroup In objDomain
	i=i+1 'Inizia dalla colonna 2 a scrivere i nomi dei gruppi
	strGruppo(i)= objGroup.Name
	oXL.Cells(1, i).Value = strGruppo(i)
next
intNumeroGruppi= i 'Qui memorizzo il numero dei gruppi che ho trovato

objDomain.Filter = Array("user")
Riga=2	'Gli utenti comincio a scriverli dalla riga 2 in poi.
for each objUser in objDomain
	oXl.cells(Riga,1).Value = objUser.Name 'Userid nella prima colonna
	for each objGroup in objUser.groups	'Per ogni gruppo di appartenenza dell'utente...
		for i=2 to intNumeroGruppi	
			if objGroup.Name = strGruppo(i)	then oXL.Cells(Riga, i).value="*"
		next 
	next
	oXl.cells(Riga,intNumeroGruppi+1).Value = objUser.FullName 'mette il nome completo nell'ultima colonna
	Riga=Riga+1
next

oXL.Range(oXL.cells(1,2),oXL.cells(1,intNumeroGruppi)).Select
oXL.Selection.Orientation = 90
oXL.Selection.Columns.AutoFit
oXL.Selection.Rows.AutoFit   
oXL.Range("A1").Select

msgbox "Cross Reference Gruppi-Utenti: Fine lavoro", ,"Xref Gruppi-Utenti"

